﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Statements
{
    enum Rainbow {red, orange, yellow,
    green, blue}
    /// <summary>
    /// тестирование работы операторов
    /// </summary>
    class Testing
    {
        Random rnd = new Random();
        const string NL = "\r\n";
        public static string STRTEST1 =
            "const int MAX = 10;" + NL +
            "int a = rnd.Next(MAX);" + NL +
            "int b = rnd.Next(MAX);" + NL +
            "if (a > b) ;" + NL +
            "else {int temp = a; a = b; b = temp;}";
        public const string RESULT1 =
            "Упрости программу, устранив пустой оператор!";
        public void Test1()
        {            
            const int MAX = 10;
            int a = rnd.Next(MAX);
            int b = rnd.Next(MAX);
            if (a > b) ;
            else
            {
                int temp = a; a = b; b = temp;
            }
        }
        /// <summary>
        /// Разбор случаев с использованием списков выражений
        /// </summary>
        /// <param name="operation">операция над аргументами</param>
        /// <param name="arg1">первый аргумент бинарной операции</param>
        /// <param name="arg2">второй аргумент бинарной операции</param>
        /// <param name="result">результат бинарной операции</param>
        public void ExprResult(string operation, double arg1, double arg2,
            ref double result)
        {
            switch (operation)
            {
                case "+":
                case "Plus":
                case "Плюс":
                    result = arg1 + arg2;
                    break;
                case "-":
                case "Minus":
                case "Минус":
                    result = arg1 - arg2;
                    break;
                case "*":
                case "Mult":
                case "Умножить":
                    result = arg1 * arg2;
                    break;
                case "/":
                case "Divide":
                case "Div":
                case "разделить":
                case "Делить":
                    result = arg1 / arg2;
                    break;
                default:
                    result = 0;
                    break;
            }
            
        }//ExprResult

        /// <summary>
        /// Поиск образца в массиве
        /// </summary>
        /// <param name="ar">массив для поиска</param>
        /// <param name="pat">образец поиска</param>
        /// <param name="patIndex">индекс найденного элемента</param>
        /// <returns>
        /// true, если найден элемент, совпадающий с образцом
        /// false, в противном случае
        /// </returns>
        public bool SearchPattern(int[] ar, int pat, out int patIndex)
        {
            int n = ar.Length;
            patIndex = -1;
            bool found = false;
            for (int i = 0; i < n; i++)
                if (ar[i] == pat)
                {
                    found = true;
                    patIndex = i;
                    break;
                }
            return found;
        }
        /// <summary>
        /// Определение палиндромов.
        /// Демонстрация цикла for
        /// </summary>
        /// <param name="str">текст</param>
        /// <returns>true - если текст является палиндромом</returns>
        public bool IsPalindrom(string str)
        {
            for (int i = 0, j = str.Length - 1; i < j; i++, j--)
                if (str[i] != str[j]) return (false);
            return (true);
        }//IsPalindrom

        /// <summary>
        /// Нормализация текста
        /// Удаление белых проблелов
        /// Приведение к нижнему регистру
        /// </summary>
        /// <param name="txt">исходный текст</param>
        /// <returns>приведенный нормализованный текст</returns>
        public string NormalizeText(string txt)
        {
            string result = "";
            char current = '0';
            int n = txt.Length;
            for (int i = 0; i < n; i++)
            {
                current = txt[i];
                if (!char.IsWhiteSpace(current))
                    result += current.ToString();
            }
            result = result.ToLower();
            return result;
        }
        /// <summary>
        /// Итератор, создающий коллекцию цветов
        /// </summary>
        /// <returns>коллекцию </returns>
        public System.Collections.IEnumerable Rainbow()
        {
            yield return "red";            
            yield return "orange";
            yield return "yellow";
            yield return "green";
            yield return "blue";
            yield return "violet";
        }
        
    }
}
